



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>SpringBoot系列: SpringBoot Web项目中使用Shiro 之二</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">SpringBoot系列: SpringBoot Web项目中使用Shiro 之二</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 18:27:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>==================================<br />Shiro 的加深理解:<br />==================================<br />1. Shiro 和 Spring 系组件的对标,<strong> Shiro = Spring Security + Spring Session</strong>. 就是说 Shiro 不仅仅是一个安全框架, 同时也是一个 Session 管理框架. 其实这也是很自然的事情, Shiro 会拦截所有的 web 请求, 通过 SecurityManager 进行安全审核, 接着 SecurityManager 又委托 SessionManager 进行 session 管理.  当然 Shiro 并没有强制我们一定要使用它来进行 Session 管理. <br />2. Shiro Session 管理: 就是和普通的 web session 管理一样, 管理 session 属性, 默认是保存在内存中, 也可以保存在分布式的存储中, 比如 redis. <br />3. Shiro cache 的内容是: 仅仅缓存 Realm 的认证和鉴权相关的数据, 不会包含 Session 属性数据.</p>
<p>默认情况下, Web 服务器端的 Session 都是保存在内存中, 如果服务重启升级, Session 就丢了, 如果是集群部署, session 保存在单机内存中也不太合适, 这时就需要引入集中 session 存储了, 现在比较流行使用 redis 存储.</p>
<p>==================================<br />Shiro 内置的 Session Manager<br />==================================<br />Session Manager, Shiro 使用 session 来管理 subject 的生命周期, 包括: 创建/停止/过期 等等, shiro 内置了三个实现: <br />1. DefaultSessionManager<br />&nbsp; &nbsp; DefaultSecurityManager 使用的默认 Session Manager, 用于 JavaSE 环境.<br />2. ServletContainerSessionManager<br />   &nbsp; &nbsp;&nbsp;DefaultWebSecurityManager 默认使用的 Session Manager, 使用 Servlet 容器服务器的会话. 如果运行在 Tomcat 中, HttpSession 接口的实现类是 org.apache.catalina.session.StandardSessionFacade.  用于 Web 环境.<br />3. DefaultWebSessionManager<br />   &nbsp; &nbsp;&nbsp;可以替代 ServletContainerSessionManager, 自定义 Session 的管理策略, 甚至包括自定义持久化方案, Shiro 提供了一个默认的 MemorySessionDAO 持久化 DAO 实现, 也有 redis 持久化方案, 比如这个开源项目, http://alexxiyang.github.io/shiro-redis/</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/194640/201812/194640-20181229150037011-720079031.png" /></p>
<p>下面是启用 DefaultWebSessionManager 的简单示例, 采用了默认的 MemorySessionDAO 来持久化 (应该是基于并发 HashMap 类).</p>
<div>
<pre class="prettyprint linenums">@Bean<br />
public DefaultWebSessionManager sessionManager() {<br />
    DefaultWebSessionManager sessionManager = new DefaultWebSessionManager();<br />
    sessionManager.setGlobalSessionTimeout(1800000l);<br />
    sessionManager.setDeleteInvalidSessions(true);<br />
    sessionManager.setSessionValidationSchedulerEnabled(true);<br />
    sessionManager.setSessionIdCookieEnabled(true);<br />
    SimpleCookie cookie = new SimpleCookie(ShiroHttpSession.DEFAULT_SESSION_ID_NAME);  //cookie 名为: JSESSIONID<br />
    cookie.setHttpOnly(true);<br />
    cookie.setMaxAge(1800000);<br />
    sessionManager.setSessionIdCookie(cookie);<br />
    return sessionManager;<br />
}</pre>
</div>
<p>==================================<br />使用 Shiro 框架后几个常用对象的具体实现类<br />==================================<br />Shiro 不管是采用 ServletContainerSessionManager 还是 DefaultWebSessionManager,  使用 Shiro 框架后, 视图方法注入的 HttpServletRequest 参数都会被替换为 shiro 的 ShiroHttpServletRequest 实现类.</p>
<p>另外需要注意, Shiro subject.getSession() 返回的 session 对象, 实现的接口是 org.apache.shiro.session.Session, 这个接口和标准 HttpSession 接口没有父子关系, 不能简单强转, Shiro 内部有相互转换的代码. <br />1. subject.getSession() 返回值的具体类: org.apache.shiro.subject.support.DelegatingSubject$StoppingAwareProxiedSession <br />2. Controller 视图方法注入的 HttpSession 接口参数, 具体实现类是 org.apache.catalina.session.StandardSessionFacade<br />3. Controller 视图方法中, 通过 request.getSession() 方法,  返回值的类型和 视图方法注入的 HttpSession 参数类型一致.</p>
<p>详情对象的类型如下:</p>
<div>
<pre class="prettyprint linenums">subject.getSession()     : org.apache.shiro.subject.support.DelegatingSubject$StoppingAwareProxiedSession<br />
httpSession              : org.apache.catalina.session.StandardSessionFacade<br />
httpRequest.getSession() : org.apache.catalina.session.StandardSessionFacade<br />
httpRequest              : org.apache.shiro.web.servlet.ShiroHttpServletRequest<br />
httpResponse             : org.apache.catalina.connector.ResponseFacade</pre>
</div>
<p>下图是几个Session类之间的关系:</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/194640/201812/194640-20181229150213782-1838022060.png" /></p>
<p>==================================<br />Shiro Session 和标准 HttpSession 的互操作性<br />==================================<br />虽然 org.apache.shiro.session.Session 接口和标准的 javax.servlet.http.HttpSession 接口没有父子关系, 它们不能简单强转, 但是对于 Session 属性管理是相通的, 经我测试, Shiro 不管是采用 ServletContainerSessionManager 作为 session 管理器, 还是采用 DefaultWebSessionManager,  两套 session 对象的属性读写是相通的.</p>
<p>这为我们提供了极大的便利, 也就是说我们既可以使用标准的 HttpSession 对象来读写 session 属性, 也可以使用 Shiro 的 Session 对象来读写.</p>
<div>
<pre class="prettyprint linenums">// HttpSession 主动写 Session 属性示例<br />
@RequestMapping("/springWrite")<br />
@ResponseBody<br />
public String springWrite(HttpServletRequest httpRequest, HttpSession httpSession){<br />
    httpSession.setAttribute("Spring_Attr", "Spring_Attr_Value");<br />
    System.out.println(httpSession.getAttribute("Spring_Attr"));

    System.out.println("=======");<br />
    Session session = SecurityUtils.getSubject()<br />
            .getSession();<br />
    System.out.println(session.getAttribute("Spring_Attr"));<br />
    return "springWrite";<br />
}

// Shiro Session 主动写 Session 属性示例<br />
@RequestMapping("/shiroWrite")<br />
@ResponseBody<br />
public String shiroWrite(HttpServletRequest httpRequest, HttpSession httpSession){<br />
    Session session = SecurityUtils.getSubject()<br />
            .getSession();<br />
    session.setAttribute("Shiro_Attr", "Shiro_Attr_value");<br />
    System.out.println(session.getAttribute("Shiro_Attr"));

    System.out.println("=======");<br />
    System.out.println(httpSession.getAttribute("Shiro_Attr"));<br />
    return "shiroWrite";<br />
}</pre>
</div>
<p>下面是 shiro session 支持的方法:</p>
<div>
<pre class="prettyprint linenums">    Session session = subject.getSession();<br />
    session.getId()<br />
    session.getTimeout())<br />
    session.getStartTimestamp();<br />
    session.getLastAccessTime();<br />
    session.setAttribute("key", "123");<br />
    session.removeAttribute("key");<br />
    session.touch();<br />
    session.stop();  </pre>
</div>
<p>在 J2SE 项目中, 使用 Subject.logout() 会自动调用 Session.stop() 方法来销毁会话, 如果在 web 中, 调用 javax.servlet.http.HttpSession.invalidate() 也会自动调用 Session.stop() 方法进行销毁 Shiro 的会话.</p>
<p>==================================<br />到底要不要让 Shiro 全面接管 Session 管理?<br />==================================<br />前面已经提到: Shiro = Spring Security + Spring Session, 在安全管理这块, 我觉得 Shiro 比 Spring Security 强太多了, Spring Security 搞的太复杂了. 现在的问题是, 要不要让 Shiro 全面接管 Session 管理?</p>
<p><strong>推荐方案是 ServletContainerSessionManager + Spring Session</strong>, 也就是说 Session 管理还是交给 Spring Session, Session 属性操作还是使用标准的HttpSession注入对象来完成,&nbsp;&nbsp;不太推荐使用 DefaultWebSessionManager 使用持久化 Session 信息.</p>
<p>说明如下:<br />1. 推荐 ServletContainerSessionManager 而不是 DefaultWebSessionManager, 这样就能更好利用 Spring Session 生态. 如果使用 DefaultWebSessionManager, 开箱即用的 SessionDAO 只有 MemorySessionDAO 和 开源的 shiro-redis (地址 http://alexxiyang.github.io/) , 生态要比 Spring Session 差. <br />比如, 我们我们<br />2.  有克制地使用 SecurityUtils.getSubject().getSession(), 虽然 Shiro Session 和标准 HttpSession 具有很好的互操作性, 但在视图方法中, 还是推荐使用 HttpSession 参数注入对象, 在 Shiro realm 实现类中, 如果要读写 session, 直接用 SecurityUtils.getSubject().getSession() 非常方便.</p>
<p>===========================<br />shiro 对 Basic和 JWT 认证的支持<br />===========================<br />上面的介绍都是基于 session-cookie 这样的安全验证,  这个小节看看shiro对于其他安全验证的支持, 常用web鉴权机制有: Login Form(session-cookie), 还有 Basic Auth,  还有jwt token或hmac token等无状态认证(即不涉及session管理), 还有 OAUTH2 (集成第三方认证).</p>
<p>Shiro 默认支持Login Form 和 BasicAuth 两种鉴证方式,  同时因为shiro灵活的架构, 基于shiro也很容易支持基于jwt token或hmac token等无状态认证.  <br />比如要支持基于jwt token的无状态认证也很容易, 需要定制的地方有:<br />1. 定制一个 JwtToken 类(继承自  AuthenticationToken), 用来代替常用的 user name /password token 类. <br />2. 在 Realm 使用该 JwtToken 类完成验证<br />3. 定义一个 JwtFilter 类(继承自AccessControlFilter), 从Request中提取 jwt token 并调用验证方法. <br />4. 自定义 DefaultWebSubjectFactory 类, 关闭默认的session持久化功能.</p>
<p>详细过程和源码, 可参考下面几个文章:<br />&nbsp; &nbsp;张开涛博客&lt;&lt;shiro 无状态Web集成&gt;&gt;  <br />&nbsp; &nbsp; &nbsp; &nbsp;https://www.vxzsk.com/1233.html <br />&nbsp; &nbsp;详细shiro jwt 构建无状态分布式鉴权体系<br />&nbsp; &nbsp; &nbsp; &nbsp;https://www.jianshu.com/p/0a5d3d07a151<br />&nbsp; &nbsp; &nbsp; &nbsp;https://www.jianshu.com/p/b0a577708a7b<br />&nbsp; &nbsp;Shiro+JWT+Spring Boot Restful简易教程<br />&nbsp; &nbsp; &nbsp; &nbsp;https://www.jianshu.com/p/f37f8c295057</p>
<p>==================================<br />参考<br />==================================<br />使用 redis 进行基于 shiro 的 session 集群共享<br />http://www.cnblogs.com/sunshine-2015/p/5686750.html<br />shiro 实现 APP、web 统一登录认证和权限管理<br />http://www.cnblogs.com/sunshine-2015/p/5515429.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq1r5dz8.html">ASP&period;NET MVC 5 Web编程2 -- URL映射&lpar;路由原理&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw0l7l9.html">PHPStorm技巧篇 -- 观感优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7d76gq.html">解决在CentOS6&period;5下安装OpenStack（Icehouse版本 ）出现的glance服务无法正常工作的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jrzo0q.html">linux的多媒体 播放 软件版权问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z5pon8.html">搜索框UISearchController的使用&lpar;iOS8&period;0以后替代UISearchBar &plus; UISearchDisplayController）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r930ewg9.html">Hibernte继承映射</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzz408.html">c&plus;&plus;l类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1wep28.html">Hadoop平台配置总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn1e708.html">zoj1136 Multiple</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jkggw8.html">Java 并发 线程的优先级</a>
		</li>
						<li><a href="https://www.batexi.com/a/9503nr08.html">Android打开某个activity时自动弹出输入法键盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pm5mn8.html">Varnish &amp;amp&semi;&amp;amp&semi; Varnish Cache</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpgjrzq.html">Myeclipse去掉恶心的弹框</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp4517q.html">Android实训案例（七）&mdash;&mdash;四大组件之一Service初步了解，实现通话录音功能，抽调接口</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj1jzz9.html">Manjaro 安装svn客户端，以及checkout使用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllexreq.html">使用jsdelivr访问github资源</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjjdn79.html">java基础-3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllo7xeq.html">hdu-5687（字典树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o31kk8.html">vue-cli webpack 全局引用jquery</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gy5zzq.html">bzoj1003&sol;luogu1772 物流运输 &lpar;dijkstra&plus;dp&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxkp71z8.html">jdbc链接数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgeej78.html">c&num;语法学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpn6mxq.html">ENABLE&lowbar;DDL&lowbar;LOGGING 参数使用 监控对象的DDL&lpar;在alter 日志记录DDL语句&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jrdrl8.html">Linux内存管理 &lpar;2&rpar;页表的映射过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z4my19.html">SpringBoot系列十：SpringBoot整合Redis</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p1pyn8.html">flask刷新token</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyd4lz9.html">【学习总结】GirlsInAI ML-diary day-14-function函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj6lwl8.html">Go 连接 mysql 数据库的简单测试&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1xen1q.html">linux  python2&period;x 升级python3&period;x</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgo4078.html">Python的数据库操作</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
